=== debian/changelog ===
linglong (1.7.4-1) unstable; urgency=medium

  * fix: old version of ll-cli cannot export the new package
  * fix: incorrect official website display in the DTK About dialog
  * refactor: no need to pullDependency during ll-builder run
  * fix: abnormal cursor size in wayland
  * fix: PM blocked in a cancled task

 -- dengbo <dengbo@deepin.org>  Wed, 18 Dec 2024 16:20:06 +0800

linglong (1.7.3-1) unstable; urgency=medium

  * release 1.7.3-1

 -- dengbo <dengbo@deepin.org>  Tue, 10 Dec 2024 19:22:29 +0800

linglong (1.7.2-1) unstable; urgency=medium

  * release 1.7.2-1

 -- dengbo <dengbo@deepin.org>  Wed, 04 Dec 2024 17:39:49 +0800

linglong (1.7.1-1) unstable; urgency=medium

  * release 1.7.1-1

 -- dengbo <dengbo@deepin.org>  Fri, 29 Nov 2024 11:28:30 +0800

linglong (1.7.0-1) unstable; urgency=medium

  * release 1.7.0-1

 -- dengbo <dengbo@deepin.org>  Fri, 01 Nov 2024 11:06:45 +0800
